/*
   simple array based table, ill make it better later
*/
#pragma once

// TableNode
//--------------------------
template <class KEY, class DATA> struct TableNode
{
   bool  active;
   KEY   key;
   DATA  data;
};


// Table
//--------------------------
template<class KEY, class DATA> class Table
{
public:
   Table( int size = 30 )
   {
      _size = size;
      _table = new TableNode<KEY,DATA>[_size];
      for(int i=0; i<_size; i++)
         _table[i].active = false;
   }

//--------------------------
   ~Table( void )
   {
      delete[] _table;
   }

//--------------------------
   bool add( KEY key, DATA data )
   {
      for(int i=0; i<_size; i++)
         if(_table[i].active == false)
         {
            _table[i].active = true;
            _table[i].key = key;
            _table[i].data = data;
            return true;
         }
      return false;
   }

//--------------------------
   DATA get( KEY key )
   {
      for(int i=0; i<_size; i++)
         if(_table[i].key == key)
            return _table[i].data;
      return 0;
   }

//--------------------------
   bool remove( KEY key )
   {
      for(int i=0; i<_size; i++)
         if(_table[i].key == key)
         {
            _table[i].active = false;
            return true;
         }
      return false;
   }

private:
   int                     _size;
   TableNode<KEY,DATA>*    _table;
};
